{$I-}
Program Prog;
uses
  crt, graph;

const
  vyska = 100;
  rozdil = 6;
  pozadi = black;

type
  string6 = string[6];
  UkPrvek = ^prvek;     {jedna nota nebo pomla}
  prvek = record        {z nich je slozen linearni seznam}
    nota : string6;
    delka : real;
    dalsi : UkPrvek;
  end;

  UkObrazek = ^Obrazek;
  obrazek = record
    pole : array[1..50, 1..50] of boolean;
    x, y : byte;
  end;
var
  skladba_z, skladba_k : UkPrvek;       {ukazuje na zacatek a na konec skladby}
  takt : byte;                          {kolika 1/4 je takt}

  klic, krizek : UkObrazek;

  nota4, nota1n, nota1d, nota2d, nota2n, nota05n, nota05d : UkObrazek;
  pomlka1, pomlka2, pomlka4, pomlka05 : UkObrazek;
  takt5, takt3, takt4 : UkObrazek;

  tento : UkPrvek;

Procedure Init;
begin
  new(skladba_z);
  skladba_z^.nota := '';
  skladba_z^.delka := 0;
  skladba_z^.dalsi := nil;
  takt := 0;
  skladba_k := skladba_z;
end;

Procedure Nacti;
{nacita noty a uklada je do linearniho senznamu}

var
  soubor : text;        {nazev souboru a soubor}
  nazev : string;

  n : byte;             {pomocne promenne na nacitanni ze souboru}
  z : char;
  kod : integer;
  vyska : string6;
  delka : real;

  novy : UkPrvek;       {pomoci neho se alokuje misto v pameti}

begin
  {zepta se na nazev souboru}
  writeln('Zadejte nazev souboru :');
  readln(nazev);
  assign(soubor, nazev);
  reset(soubor);
  if ioresult <> 0 then
    begin
      writeln('Nelze otevrit soubor');
      readln;
      halt;
    end;

  {precte takt}
  read(soubor, z);
  readln(soubor);
  val(z, n, kod);
  if  n in [3..5] then
    begin
      writeln('Spatny takt, bude nastavaen na 4/4');
      takt := 4;
    end;

  {cte noty}
  while not eof(soubor) do
    begin
      vyska := '';
      read(soubor, z);
      while z <> ' ' do
        begin
          insert(z, vyska, length(vyska)+1);
          read(soubor, z);
        end;
      readln(soubor, delka);
      new(novy);
      novy^.nota := vyska;
      novy^.delka := delka;
      novy^.dalsi := nil;
      skladba_k^.dalsi := novy;
      skladba_k := novy;
    end;

  close(soubor);
end;

Procedure Zapis(nazev : string);
{zapise noty do souboru}

var
  soubor : text;        {soubro do ktereho se zapisuje}
  tento : UkPrvek;      {ukazuje na notu ktera se vypisuje}

begin
  assign(soubor, nazev);
  rewrite(soubor);
  if ioresult <> 0 then
    begin
      writeln('Chyba pri vytvareni souboru');
      readln;
      halt;
    end;

  {napise takt}
  write(soubor,takt);
  writeln(soubor, '\4');
  tento := skladba_z^.dalsi;

  {vypise noty}
  while tento <> nil do
    begin
      write(soubor, tento^.nota, ' ');
      writeln(soubor, tento^.delka:1:1);
      tento := tento^.dalsi;
    end;

  close(soubor);
end;

Procedure GraphInit;
{inicializuje grafiku}
var
  rezim, ovladac : integer;

begin
  detectgraph(rezim, ovladac);
  initgraph(rezim, ovladac, '');
end;

Procedure Osnova;
begin
 line(0, vyska, getmaxx, vyska);
 line(0, vyska+rozdil, getmaxx, vyska+rozdil);
 line(0, vyska+2*rozdil, getmaxx, vyska+2*rozdil);
 line(0, vyska+3*rozdil, getmaxx, vyska+3*rozdil);
 line(0, vyska+4*rozdil, getmaxx, vyska+4*rozdil);
end;

Procedure NactiObrazky;
{nacte vsechny obrazky (noty) ze souboru pro pozdejsi pouziti}
const
  cesta = 'Obr/';

Procedure Cti(nazev:string; var tento:UkObrazek);
var
  soubor : text;
  x, y : byte;
  z : char;


begin
  new(tento);
  assign(soubor, cesta + nazev+'.txt');
   reset(soubor);
  read(soubor, tento^.x);
  readln(soubor, tento^.y);
  for  y := 1 to tento^.y do
    begin
      for x := 1 to tento^.x do
        begin
          read(soubor, z);
          if z = '.' then
            tento^.pole[x, y] := false
          else
            if z = '@' then
              tento^.pole[x, y] := true;
        end;
      readln(soubor);
    end;
  close(soubor);
end;

begin
  Cti('klic', klic);
  Cti('krizek', krizek);

  Cti('nota1d', nota1d);
  Cti('nota2d', nota2d);
  Cti('nota4', nota4);
  Cti('nota05d', nota05d);
  Cti('nota1n',nota1n);
  Cti('nota2n',nota2n);
  Cti('nota05n',nota05n);

  Cti('takt3',takt3);
  Cti('takt4',takt4);
  Cti('takt5',takt5);
end;

Procedure Vykresli(tento:UkObrazek; x, y : integer);
{vykresli dany obrazek (notu)}
const
  barva = white;

var
  i, j : integer;

begin
  for i := 1 to tento^.x do
    for j := 1 to tento^.y do
      if tento^.pole[i, j] = true then
        putpixel(i+x-1, j+y-1, barva)
      else
        putpixel(i+x-1, j+y-1, pozadi);
end;


Procedure NakresliOd(tento : UkPrvek);
{vykresli noty az do konce obrazovky od noty oznacene ukazatelem tento}
const
  mezera = 10;

var
  x : integer;
  y : integer;
  ten : UkObrazek;
  dolu : boolean;
  tecka : boolean;
  vykreslovat : boolean;
  dob : real;
  kri : boolean;
  pomlka : boolean;


begin
  {vzdy vykresli dany znak a pak kresli na pozici o mezeru a sirku znaku dale}
  {pokud je to 1 nota vykresli houslovy klic a takt}
  x := 0;
  if tento = skladba_z^.dalsi then
    begin
      vykresli(klic, x, vyska-17);
      x := x + klic^.x +mezera div 2;
      case takt of
        3 : ten := takt3;
        4 : ten := takt4;
        5 : ten := takt5;
      end;
      vykresli(ten, x, vyska+1);
      x := x+ten^.x + mezera;
    end;
  while (x <> getmaxx-50) and (tento <> nil) do
    begin
      dob := 0;
      while (dob <> takt) and (tento <> nil) do
        begin
          tecka := false;
          vykreslovat := true;
          kri := false;
          pomlka := true;
          if tento^.nota='C' then
            begin
              dolu := false;
              y := vyska+5*rozdil;
            end
          else
          if tento^.nota='Cis' then
            begin
              dolu := false;
              y := vyska+5*rozdil;
              kri := true;
            end
          else
          if tento^.nota ='D' then
            begin
              dolu := false;
              y := vyska+round(4.5*rozdil);
              kri := false;
            end
          else
          if tento^.nota ='Dis' then
            begin
              dolu := false;
              y := vyska+round(4.5*rozdil);
              kri := true;
            end
          else
            if tento^.nota ='E' then
            begin
              dolu := false;
              y := vyska+round(4*rozdil);
              kri := false;
            end
          else
            if tento^.nota ='F' then
            begin
              dolu := false;
              y := vyska+round(3.5*rozdil);
              kri := false;
            end
          else
            if tento^.nota ='Fis' then
            begin
              dolu := false;
              y := vyska+round(3.5*rozdil);
              kri := true;
            end
          else
            if tento^.nota ='G' then
            begin
              dolu := false;
              y := vyska+round(3.0*rozdil);
              kri := false;
            end
          else
            if tento^.nota ='Gis' then
            begin
              dolu := false;
              y := vyska+round(3.0*rozdil);
              kri := true;
            end
          else
            if tento^.nota ='A' then
            begin
              dolu := false;
              y := vyska+round(2.5*rozdil);
              kri := false;
            end
          else
            if tento^.nota ='Ais' then
            begin
              dolu := false;
              y := vyska+round(2.5*rozdil);
              kri := false;
            end
          else
            if tento^.nota ='H' then
            begin
              dolu := false;
              y := vyska+round(2*rozdil);
              kri := false;
            end
          else
            if tento^.nota ='c' then
            begin
              dolu := true;
              y := vyska+round(1.5*rozdil);
              kri := false;
            end
          else
            if tento^.nota ='cis' then
            begin
              dolu := true;
              y := vyska+round(1.5*rozdil);
              kri := true;
            end
          else
            if tento^.nota ='d' then
            begin
              dolu := true;
              y := vyska+round(1.0*rozdil);
              kri := false;
            end
          else
            if tento^.nota ='dis' then
            begin
              dolu := true;
              y := vyska+round(1.0*rozdil);
              kri := true;
            end
            else
            if tento^.nota ='e' then
            begin
              dolu := true;
              y := vyska+round(0.5*rozdil);
              kri := false;
            end
            else
            if tento^.nota ='f' then
            begin
              dolu := true;
              y := vyska+round(0*rozdil);
              kri := false;
            end
            else
            if tento^.nota ='fis' then
            begin
              dolu := true;
              y := vyska+round(0*rozdil);
              kri := true;
            end
            else
            if tento^.nota ='g' then
            begin
              dolu := true;
              y := vyska-round(0.5*rozdil);
              kri := false;
            end
            else
            if tento^.nota ='gis' then
            begin
              dolu := true;
              y := vyska-round(0.5*rozdil);
              kri := true;
            end
            else
            if tento^.nota ='a' then
            begin
              dolu := true;
              y := vyska-round(1.0*rozdil);
              kri := false;
            end
            else
            if tento^.nota ='ais' then
            begin
              dolu := true;
              y := vyska-round(1.0*rozdil);
              kri := true;
            end
            else
            if tento^.nota ='h' then
            begin
              dolu := true;
              y := vyska-round(1.5*rozdil);
              kri := false;
            end
            else
            if tento^.nota ='pomlka' then
            begin
              y := vyska+round(2*rozdil);
              kri := false;
              pomlka := true;
              if tento^.delka = 4 then
                ten := pomlka4
              else
               if tento^.delka = 2 then
                ten := pomlka2
              else
             if tento^.delka = 1 then
                ten := pomlka1
             else
             if tento^.delka = 0.5 then
                ten := pomlka05
            end
            else
              vykreslovat := false;

            if pomlka = true then
          if dolu = true then
            begin
              if tento^.delka = 4 then
                ten := nota4
              else
                if tento^.delka = 3 then
                  begin
                    ten := nota2d;
                    tecka := true;
                  end
                else
                  if tento^.delka = 2 then
                    ten := nota2d
                  else
                    if tento^.delka = 1.5 then
                      begin
                        ten := nota1d;
                        tecka := true;
                      end
                    else
                      if tento^.delka = 1 then
                        ten := nota1d
                      else
                        if tento^.delka = 0.5 then
                          ten := nota05d
                        else
                          vykreslovat := false;
            end
          else
            begin
              if tento^.delka = 4 then
                ten := nota4
              else
                if tento^.delka = 3 then
                  begin
                    ten := nota2n;
                    tecka := true;
                  end
                else
                  if tento^.delka = 2 then
                    ten := nota2n
                  else
                    if tento^.delka = 1.5 then
                      begin
                        ten := nota1n;
                        tecka := true;
                      end
                    else
                      if tento^.delka = 1 then
                        ten := nota1n
                      else
                        if tento^.delka = 0.5 then
                          ten := nota05n
                        else
                          vykreslovat := false;
            end;

          if kri = true then
            begin
              vykresli(krizek, x, y -2-mezera div 2);
              x := x+3+krizek^.x;
            end;
          if vykreslovat = true then
            vykresli(ten, x, y-ten^.y+mezera div 2);
          x := x + ten^.x;
          if tecka = true then
            begin
              x := x + 3;
              putpixel(x,y+1, white);
              putpixel(x+1,y+1, white);
              putpixel(x+1,y, white);
              putpixel(x,y, white);
              x := x + 3;
            end;
          x := x+mezera;
          dob := tento^.delka;
          tento := tento^.dalsi;
        end;
      line(x, vyska, x, vyska+4*rozdil);
      x := x +3;
    end;
      line(x, vyska, x, vyska+4*rozdil);
      x := x +3;

end;

begin
  clrscr;
  Init;
  Nacti;
  writeln;
  writeln('Znakem p se posoucvaji noty doprava');
  writeln('Zmacknete enter');
  readln;
{  Zapis('nic.txt');}
  GraphInit;
  NactiObrazky;
  NakresliOd(skladba_z^.dalsi);
  tento := skladba_z^.dalsi;
  Osnova;
  while readkey = 'p' do
    begin
      tento := tento^.dalsi;
      nakresliod(tento);
    end;
end.